<template>
  <div class="component-container bg-white px-[39px]">
    <div class="relative pt-5">
      <section
        class="flex h-[80px] pt-1 swiper game-provider-swiper w-full mb-[15px] swiper-initialized swiper-horizontal swiper-pointer-events"
      >
        <swiper
          :modules="modules"
          :slides-per-view="5"
          :navigation="providers.length > 6"
          class="swiper-wrapper games-swiper"
        >
          <template v-for="provider in providers" :key="provider.providerId">
            <swiper-slide class="flex flex-col items-center justify-center swiper-slide">
              <div class="flex flex-row items-center logo-tags gap-1 china-btn__tag china-btn__tag__new z-20">
                <img
                  v-if="provider.isNewProvider"
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/new_icon.svg'
                    )
                  "
                />
                <img
                  v-if="provider.isHotProvider"
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/hot_icon.svg'
                    )
                  "
                />
              </div>
              <div
                class="group hover:text-white"
                :class="`${
                  (subTabInitial === provider.ProviderName) && !searchModel
                    ? 'active-provider'
                    : 'game_tab'
                } ${
                  provider.IsMaintain
                    ? 'grayscale-[1] pointer-events-none'
                    : 'cursor-pointer'
                }`"
                :style="`--btnActiveBg: ${btnActiveBg};`"
                @click="
                  provider.IsMaintain
                    ? () => ''
                    : filterGame('Provider', provider.ProviderName)
                "
              >
                <div class="flex items-center w-4/5">
                  <img
                    :class="{ hidden: subTabInitial === provider.ProviderName }"
                    class="w-[32px] h-[32px] mr-3 block inactive-img-provider"
                    :src="
                      handleImportImage(
                        `/light_flexible_1/desktop/images/productHover/${handleRemoveSpaceSpecialCharFormatted(
                          provider.ProviderName
                        )}logo.png`
                      )
                    "
                    alt="logo"
                  />
                  <img
                    :class="
                      subTabInitial === provider.ProviderName
                        ? 'block'
                        : 'hidden'
                    "
                    class="w-[32px] h-[32px] mr-3 active-img-provider"
                    :src="
                      handleImportImage(
                        `/light_flexible_1/desktop/images/productHover/activeIco/${handleRemoveSpaceSpecialCharFormatted(
                          provider.ProviderName
                        )}logo.png`
                      )
                    "
                    alt="logo"
                  />
                  <div
                    class="text-[13px]"
                    :class="{
                      'text-white': (subTabInitial === provider.ProviderName) && !searchModel,
                    }"
                  >
                    {{ provider.NameForDisplay }}
                  </div>
                </div>
              </div>
            </swiper-slide>
          </template>
        </swiper>
      </section>
    </div>
    <div class="w-full border-t-[1px] py-[24px] flex justify-between">
      <div class="grid grid-cols-4 gap-5 filter">
        <template v-if="authenticated">
          <div
            v-for="authType in authTypes"
            :key="authType"
            class="flex items-center cursor-pointer filter-item"
            @click="filterGame(authType)"
          >
            <div class="filter-icon">
              <img
                class="block img-inactive"
                :class="{ hidden: subTabInitial === authType }"
                :src="
                  handleImportImage(
                    `/light_flexible_1/desktop/images/productHover/${handleRemoveSpaceSpecialCharFormatted(
                      authType
                    )}logo.png`
                  )
                "
                alt=""
              />
              <img
                :class="subTabInitial === authType ? 'block' : 'hidden'"
                class="img-active"
                :src="
                  handleImportImage(
                    `/light_flexible_1/desktop/images/productHover/activeIco/gameType/${handleRemoveSpaceSpecialCharFormatted(
                      authType
                    )}logo.png`
                  )
                "
                alt=""
              />
            </div>
            <span
              :class="
                (subTabInitial === authType)  && !searchModel ? 'text-[#4176fa]' : 'text-[#666666]'
              "
              class="hover:text-[#4176fa] text-[16px]"
              >{{ $t(authType.replace(' ', '_')) }}</span
            >
          </div>
        </template>
        <div
          v-for="gameType in gameTypes"
          :key="gameType"
          class="flex items-center cursor-pointer filter-item"
          @click="filterGame('GameType', gameType)"
        >
          <div class="filter-icon">
            <SvgIcon class="w-[20px] h-[20px]" :class="subTabInitial === gameType && !searchModel ? 'active-svg' : 'inactive-svg'"
            :svg-name="handleRemoveSpaceSpecialCharFormatted(gameType)" />
          </div>
          <span
            :class="
              (subTabInitial === gameType)  && !searchModel ? 'text-[#4176fa]' : 'text-[#666666]'
            "
            class="active-text text-[16px]"
            >{{ $t(handleRemoveSpaceSpecialCharFormatted(gameType)) }}</span
          >
        </div>
      </div>
      <form
        class="flex border-0 relative justify-end pl-[15px] game-search-form"
        @submit.prevent="updateSearchResult"
      >
        <el-input
          v-model="searchModel"
          style="width: 285px"
          :placeholder="$t('Search All Games')"
          @input="searching"
        />
        <el-button
          id="game-search-submit-button"
          style="padding: 8px 12px; margin-left: 8px; height: 36px;"
          class="button--t4 whitespace-nowrap h-[40px] search-button uppercase"
          type="primary"
          native-type="submit"
        >
          <font-awesome-icon icon="search" class="w-4 h-4 pr-1" />
          {{ $t("search") }}
        </el-button>
      </form>
    </div>
    <div
      v-infinite-scroll="gameLoading"
      v-loading="isLoading"
      class="blog-game grid grid-cols-5 gap-3"
      :class="isLoading ? 'pb-20' : ''"
    >
      <div
        v-for="init in gameReadyToRender"
        :key="init.GameId"
        class="game-item relative game p-0 rounded-lg flex flex-col w-[214px]"
      >
        <div class="h-[134px] game-img flex justify-center group">
          <!-- <IconFavorite
            :gameData="init"
            :checkIsFavourite="checkIsFavourite"
            :redirectToLogin="redirectToLogin"
            :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/> -->
          <!-- <span class="icon-status" :class="checkStatus(init)"></span> -->
          <div class="flex flex-col items-center gap-1 pl-2 pt-2 china-game__tag">
            <img
              v-if="init.IsNewGame"
              :src="
                getAssetImage(
                  'assets/theme/common/icon/new_icon.svg'
                )
              "
            />
            <img
              v-if="init.IsHotGame"
              :src="
                getAssetImage(
                  'assets/theme/common/icon/hot_icon.svg'
                )
              "
            />
          </div>
          <img v-lazy="isImageVersionExist(init.GameIconUrl)" class="h-[134px]" />
          <div
            v-if="authenticated"
            class="game-hover"
            @click="
              handleGameEntryOpenWindow(
                init,
                850,
                850,
                EnumEntranceLocation.GameLobby
              )
            "
          >
            <el-button>{{ $t("play_now") }}</el-button>
          </div>
          <nuxt-link v-else to="/login" class="game-hover">
            <el-button>{{ $t("play_now") }}</el-button>
          </nuxt-link>
        </div>
        <div class="h-[47px] flex justify-center items-center px-3 text-[16px]">
          <span>{{ init.GameName }}</span>
        </div>
      </div>
    </div>
    <el-backtop :right="30" :bottom="30">
      <div class="w-[35px] h-[35px] flex items-center justify-center">
        <font-awesome-icon icon="arrow-up" class="text-black" />
      </div>
    </el-backtop>
    <div
      v-show="gameCollection?.length === 0 && !isLoading"
      class="col-span-3 pb-[50px] pt-[40px] overflow-hidden text-4xl text-center truncate no-data text-ellipsis"
    >
      <span v-if="activeTab !== 'favorite'">
        {{ $t("no_games_please_come_back_later") }}
      </span>
      <span v-else>{{ $t("No game has been added to favorite.") }}</span>
    </div>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { defineComponent, onMounted, watch, ref, computed } from "vue";
import { Navigation } from "swiper";
import { useRoute, useRouter } from "vue-router";
import { store } from "@/store";
import {
  useGameEntryComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { IGameBsi } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  setup() {
    const { ...props } = useGameEntryComponent();
    const { setAndUnsetGameToFavourite, checkIsFavourite, redirectToLogin } =
      useAddToFavorite();
    const isShowStaus = ref(true);
    const { getAssetImage, handleRemoveSpaceSpecialCharFormatted } =
      commonHelper;
    const authTypes = ["hot games", "new games"];
    const route = useRoute();
    const router = useRouter();
    const filterGame = (type: string, game?: string) => {
      router.push(
        `/games/${game !== undefined ? game : type}__n__${
          type === "Provider" ? "gp" : "gt"
        }`
      );
      props.handleSelectedTabOption(type, game);
    };
    const checkStatus = (game: IGameBsi): string => {
      let status = "disabled";
      if (isShowStaus.value) {
        if (game.IsNewGame && !game.IsHotGame) status = "new";
        if (game.IsHotGame) status = "hot";
      }
      return status;
    };
    const checkIsGameType = (params: string) =>
      props.gameTypes.value.includes(params);
    function checkGameType() {
      if (props.filtered.value === "") {
        if (!props.authenticated.value) {
          props.handleSelectedTabOption("GameType", props.gameTypes.value[0]);
        } else {
          props.handleSelectedTabOption(authTypes[0]);
        }
      } else {
        const game = String(props.filtered.value.slice(0, -7));
        const isGameType = checkIsGameType(game);
        const isHotOrNewGame = authTypes.includes(game);
        if (props.authenticated.value && isHotOrNewGame) {
          props.handleSelectedTabOption(game);
        } else {
          props.handleSelectedTabOption(
            isGameType ? "GameType" : "provider",
            game
          );
        }
      }
    }
    checkGameType();
    watch(
      () => route.params.filter,
      () => {
        if (route.params.filter !== undefined) {
          props.filtered.value = route.params.filter;
          checkGameType();
        }
      }
    );
    onMounted(() => {
      window.scrollTo(0, 0);
    });
    const handleImportImage = (path = "") => {
      try {
        return getAssetImage(`assets/theme${path}`);
      } catch (e) {
        return path;
      }
    };
    const searchModel = ref(props.searchedGame.value);
    // let timeout: any = null;
    const searching = (_e: any) => {
      // clearTimeout(timeout);
      // timeout = setTimeout(() => {
      props.searchedGame.value = searchModel.value;
      props.handleSearchGame();
      if (!_e) props.updateSearchResult();
      // }, 800);
    };
    const btnActiveBg = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/btn-background-active.png"
    )})`;
    const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
    const index = ref(0);
    const gameRender = computed(() => {
      const chunkSize = 20;
      const games = [];
      if (props.gameCollection.value !== undefined) {
        for (
          let i = 0;
          i < props.gameCollection.value.length;
          i += chunkSize
        ) {
          const chunk: Array<IGameBsi> | undefined =
            props.gameCollection.value.slice(i, i + chunkSize);
          games.push(chunk);
        }
      }
      return games;
    });
    const gameRenderer = () => {
      gameRender.value[index.value].forEach((item) => {
        gameReadyToRender.value?.push(item);
      });
    };
    watch(gameRender, () => {
      gameReadyToRender.value = [];
      index.value = 0;
      if (gameRender.value.length) {
        gameRenderer();
      }
    });
    const gameLoading = () => {
      index.value += 1;
      if (index.value < gameRender.value.length) {
        gameRenderer();
      }
    };
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, "?v=")) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    return {
      ...props,
      handleGameEntryOpenWindow,
      modules: [Navigation],
      authTypes,
      handleRemoveSpaceSpecialCharFormatted,
      EnumEntranceLocation,
      handleImportImage,
      filterGame,
      getAssetImage,
      btnActiveBg,
      searchModel,
      searching,
      gameReadyToRender,
      gameLoading,
      isImageVersionExist,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
      checkStatus,
    };
  },
});
</script>

<style lang="scss" scoped>
.china-btn__tag,
.china-btn__tag__new {
  position: absolute;
  right: 14px;
  top: 8px;
}
.china-btn__tag {
  background-color: var(--bk8-btn-color);
}
.china-btn__tag__new {
  background-color: var(--tertiary);
}
.china-game__tag {
  position: absolute;
  left: 0;
}
.blog-game {
  .icon-status:not(.disabled) {
    position: absolute;
    width: 60px;
    height: 28px;
    border-bottom-right-radius: 16px;
    top: 0px;
    left: 0px;
    color: var(--text5);
    text-align: center;
    font-family: "Roboto";
    font-style: normal;
    font-weight: 700;
    font-size: 16px;
    letter-spacing: 0.02em;
    z-index: 20;
    &.new {
      background-color: #2A71DC;
      &::after {
        content: "New";
      }
    }
    &.hot {
      background-color: #FF264D;
      &::after {
        content: "Hot";
      }
    }
  }
}
:deep(.el-input) {
  --el-input-focus-border-color: rgb(216, 216, 216);
  --el-input-hover-border-color: rgb(216, 216, 216);
}
:deep(.swiper-wrapper.games-swiper) {
  padding-left: 26px;
  padding-right: 28px;
  max-width: 95%;
}
.game_tab {
  height: 50px;
  background: linear-gradient(
    180deg,
    rgba(254, 254, 255, 1) 0%,
    rgba(249, 250, 254, 1) 30%,
    rgba(238, 241, 253, 1) 70%,
    rgba(233, 237, 252, 1) 100%
  );
  transition: 0.3s ease-in-out;
  border-radius: 13px;
  display: flex;
  justify-content: center;
  align-items: center;
  width: 194px;
  border-radius: 70px;
  box-shadow: 0 2px 4px 0 #5da7eb;
}
.game_tab:hover {
  background: linear-gradient(
    180deg,
    rgba(98, 179, 255, 1) 0%,
    rgba(92, 169, 255, 1) 30%,
    rgba(72, 132, 247, 1) 70%,
    rgba(72, 132, 247, 1) 100%
  );
  -webkit-animation-name: hoveringAnimation;
  animation-name: hoveringAnimation;
  -webkit-animation-duration: 0.5s;
  animation-duration: 0.5s;
}
.game_tab:hover .active-img-provider {
  display: block;
}
.game_tab:hover .inactive-img-provider {
  display: none;
}
:deep(.games-swiper .swiper-button-prev::after) {
  font-size: 44px;
  position: absolute;
  top: 22%;
  width: 31px;
  display: flex;
  justify-content: center;
}
:deep(.games-swiper .swiper-button-prev) {
  background: #fff;
  translate: -10px -38px;
  width: 30px;
  height: 80px;
}
:deep(.games-swiper .swiper-button-next::after) {
  font-size: 44px;
  position: absolute;
  top: 22%;
  width: 27px;
}
:deep(.games-swiper .swiper-button-next) {
  background: #fff;
  translate: 14px -38px;
  width: 30px;
  height: 80px;
}
.filter-icon {
  width: 20px;
  height: 20px;
  margin-right: 10px;
}
.filter-icon .active-svg {
  fill: #5EADFE;
}
.filter-icon .inactive-svg {
  fill: #B1B9D3;
}
.filter-item:hover .filter-icon .inactive-svg {
  fill: #5EADFE;
}
.filter-item:hover .active-text {
  color: #4176fa;
}
.filter-item:hover .img-active {
  display: block;
}
.filter-item:hover .img-inactive {
  display: none;
}
:deep(.el-input__suffix) {
  height: 32px;
}
:deep(.el-input__suffix-inner) {
  align-items: center;
}
:deep(.el-input__inner::placeholder) {
  color: #6c7ba8;
}
:deep(.el-input__inner) {
  height: 36px;
  width: 100%;
}
:deep(.el-input__wrapper) {
  width: 100%;
}
.game-hover {
  width: 100%;
  height: 100%;
  position: absolute;
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: rgba(0, 0, 0, 0.5);
  transition: 0.3s ease-in-out;
  top: -134px;
}
.game-img {
  background-position: 50% !important;
  background-size: contain !important;
  background-repeat: no-repeat !important;
  transition: 0.3s ease-in-out;
  position: relative;
}
.game-img:hover .game-hover {
  top: 0;
  animation: fadeDown 0.5s ease backwards;
}
.game {
  border: 1px solid #ededed;
  overflow: hidden;
  margin-bottom: 12px;
}
.active-provider {
  height: 50px;
  background-image: var(--btnActiveBg);
  background-size: cover;
  background-position: 50%;
  transition: 0.3s ease-in-out;
  border-radius: 13px;
  display: flex;
  justify-content: center;
  align-items: center;
  width: 194px;
  border-radius: 70px;
  box-shadow: 0 2px 4px 0 #5da7eb;
}
.game-hover button {
  cursor: pointer;
  border: none;
  text-align: center;
  line-height: 30px;
  color: #fff;
  min-width: 107px;
  width: fit-content;
  height: 30px;
  font-size: 12px;
  background: #4176fa;
  border-radius: 4px;
}
@keyframes fadeDown {
  0% {
    transform: translate(0, -100px);
    opacity: 1;
  }
  100% {
    transform: translate(0, 0);
    opacity: 1;
  }
}
.swiper-slide.flex {
  display: flex;
}

.game-search-form {
  height: fit-content;
}
</style>
